#ifndef REFRACTION_H
#define REFRACTION_H

/****************************************/
/***** The refraction shader class ******/
/****************************************/

#include <Cg/cgGL.h>	//include the OpenGL runtime API (includes cg.h)
#include <iostream>		//include the C++ standard I/O streams
#include <string>		//include the standard windows string library

#include "Camera.h"

using namespace std;
using namespace Eigen;



class Refraction
{
	public:
		Refraction(void);
		~Refraction(void);
				 
		static void enableShader(void);
		static void disableShader(void);
		static void setShaderParameters(Vector3f *lightPosition, Vector3f cameraPosition);
		//static void updateCubeMap(void);
		static void drawCubeMap(void);

	protected:

	private:
		Camera *camObject;
		static CGprogram *cgVertexProgram;
		static CGprogram *cgFragmentProgram;
		static CGprofile *cgVertexProfile;
		static CGprofile *cgFragmentProfile;

		static CGparameter cgModelViewProj;
		static CGparameter cgModelViewIT;
		static CGparameter cgModelView;
		static CGparameter cgEyePositionV;
		static CGparameter cgEyePositionF;
		static CGparameter cgLightPosition;
		static CGparameter cgEnvironmentMap;
		static CGparameter cgNormalMap;

		static CGcontext cgContext;	//A context is a container for multiple Cg programs.

		static GLuint cubemapTextureID;
		static GLuint normalMapID;
		static char buffer[1024];
		static int cubeSides[];

		static void initCg(CGprofile *cgVertexProfile, CGprofile *cgFragmentProfile,
						   CGprogram *cgVertexProgram, CGprogram *cgFragmentProgram);

		static void loadCubeMap(void);
		static void loadNormalMap(void);
		static void cgErrorCallback(void);

};
#endif //REFRACTION_H
