#ifndef SHADOW_MAPPING_H
#define SHADOW_MAPPING_H

/****************************************/
/***** The ShadowMapping shader class ******/
/****************************************/

#include <Cg/cgGL.h>	//include the OpenGL runtime API (includes cg.h)
//#include <iostream>		//include the C++ standard I/O streams
//#include <string>		//include the standard windows string library

#include "Camera.h"

using namespace std;
using namespace Eigen;



class ShadowMapping
{
	public:
		ShadowMapping(GLuint shadowMapTexture);
		~ShadowMapping(void);
				 
		static void enableShader(void);
		static void disableShader(void);
		static void setShaderParameters(Vector3f *lightPosition, Vector3f cameraPosition);
		static void drawShadowMap(void);

	protected:

	private:
		Camera *camObject;
		static CGprogram *cgVertexProgram;
		static CGprogram *cgFragmentProgram;
		static CGprofile *cgVertexProfile;
		static CGprofile *cgFragmentProfile;

		static CGparameter cgModelViewProj;
		static CGparameter cgModelViewIT;
		static CGparameter cgModelView;
		static CGparameter cgEyePosition;
		static CGparameter cgLightPosition;

		static CGcontext cgContext;	//A context is a container for multiple Cg programs.

		static char buffer[1024];

		static void initCg(CGprofile *cgVertexProfile, CGprofile *cgFragmentProfile,
						   CGprogram *cgVertexProgram, CGprogram *cgFragmentProgram);

		static void loadShadowMap(GLuint shadowMapTexture);
		static void cgErrorCallback(void);

};
#endif //SHADOW_MAPPING_H
